import java.util.*;

public class CountryComparatorByArea_fn implements Comparator<Country>
{
   Fn fn; // functor that holds <, >, <=, or >=

   CountryComparatorByArea_fn(Fn fn)
   {
      this.fn = fn;
   }

   public int compare(Country country1, Country country2)
   {
      if ( fn.fn(country1.getArea(), country2.getArea()) ) return -1;
      if (!fn.fn(country1.getArea(), country2.getArea()) ) return  1;
      return 0;
   }
}